proc change_fmt {} {
global entree 
global f

regsub gif|pgm|ppm|tif|jpg|bmp $entree(result) $entree(format) entree(result)
}

proc Select_fichier {action} {
global entree
global f

set w .filebox
toplevel $w
wm title $w "Selection de fichiers"
wm iconname $w "filebox"

label $w.msg -wraplength 4i -justify left -text "Nom du fichier ?"
pack $w.msg -side top
 
frame $w.buttons
pack $w.buttons -side bottom -fill x -pady 2m
button $w.buttons.cancel -text "Annuler" -command {set entree(ok) 0}
button $w.buttons.ok -text "OK" -command {set entree(ok) 1}
pack $w.buttons.cancel $w.buttons.ok -side left -expand 1

   set f [frame $w.$action]
if {$action == "sauvegarder"} {
    set entree(result) "sans_titre.gif"
} else { 
    set entree(result) ""
}
    label $f.lab -text "$action : " -anchor e
    entry $f.ent -width 20 -textvar entree(result)
    bind $f.ent <Return> {set entree(ok) 1}
    button $f.but -text "Parcourir ..." -command "fileDialog $w $f.ent $action"
    pack $f.lab -side left
    pack $f.ent -side left -expand yes -fill x
    pack $f.but -side left
    pack $f -fill x -padx 1c -pady 3

    checkbutton $w.strict -text "Look Motif" \
	-variable tk_strictMotif -onvalue 1 -offvalue 0
    pack $w.strict -anchor c

if {$action == "sauvegarder"} {
    set g [label $w.form_choice]
   label $g.texte -text "Format de sauvegarde"
   radiobutton $g.gif -variable entree(format) -value "gif" -text "gif" -command "change_fmt"
   radiobutton $g.pgm -variable entree(format) -value "pgm" -text "pgm" -command "change_fmt"
   radiobutton $g.ppm -variable entree(format) -value "ppm" -text "ppm" -command "change_fmt"
   radiobutton $g.tiff -variable entree(format) -value "tif" -text "tiff" -command "change_fmt"
   radiobutton $g.jpg -variable entree(format) -value "jpg" -text "jpg" -command "change_fmt"
   radiobutton $g.bmp -variable entree(format) -value "bmp" -text "bmp" -command "change_fmt"
   set entree(format) "gif"
   pack $g.texte -in $w.form_choice -side top
   pack $g.gif $g.pgm $g.ppm $g.tiff $g.jpg $g.bmp -in $w.form_choice -side left
   pack $g -side top
}
    
focus $f.ent
grab $w
tkwait variable entree(ok)
grab release $w
destroy $w

}

proc fileDialog {w ent operation} {
global entree

    switch $operation {
"sauvegarder" {
     set types {
	 {"Image"   {.gif .pgm .ppm .tif .jpg .bmp}     }
	 {"Autres fichiers"		*}
     }
 set entree(result) [tk_getSaveFile -filetypes $types -parent $w \
 -initialfile "sans_titre" -defaultextension .$entree(format) -title "sauver"]
 }
 "ouvrir" {
     set types {
	 {"Images gif"		{.gif}		}
	 {"Images pgm"		{.pgm}	        }
	 {"Images ppm"		{.ppm}		}
	 {"Images jpeg"		{.jpg .jpeg}	        }
	 {"Images tiff"		{.tif .tiff}		}
	 {"Images bmp"		{.bmp}	        }
	 {"Autres fichiers"		*}
     }
set entree(result) [tk_getOpenFile -filetypes $types -parent $w \
			  -title $operation]
    }
     "enregistrer_macro" {
	 set types {
	     {"Fichiers macro" {.mac}}
	     {"Autre fichiers" *}
	 }
  set entree(result) [tk_getSaveFile -filetypes $types -parent $w \
 -initialfile "sans_titre" -defaultextension .mac -title "Enregistrer macro"]
 }
      "charger_macro" {
       set types {
	     {"Fichiers macro" {.mac}}
	     {"Autre fichiers" *}
	 }
set entree(result) [tk_getOpenFile -filetypes $types -parent $w \
			  -title $operation]
    }
}
}

proc nouveau {} {
global index 
global entree

Select_fichier ouvrir
    if {$entree(ok)} {
incr index
NewInti $index $entree(result)
}
}

proc set_titre {image numero} {
global version

if {$image == ""} {
    set texte "Aucune image charge"
} else {
    set texte [list Image [image width image($numero)] x [image height image($numero)]]
}
wm title .inti$numero [concat Inti $version : $texte]
}

proc save {im_num} {
global entree

Select_fichier sauvegarder
    if {$entree(ok)} {
      switch $entree(format) {
       "ppm" {$im_num write $entree(result) -format PPM/PGM}
       "pgm" {$im_num save $entree(result)}
       "gif" {$im_num write $entree(result) -format GIF}
       "tif" {$im_num write $entree(result) -format TIFF}
       "bmp" {$im_num write $entree(result) -format BMP}
       "jpg" {$im_num write $entree(result) -format JPEG}
}
}
}


proc recup {num img} {
image create photo image($num) -file $img -palette 256
Imgnew image($num) module($num) phase($num)
mise_a_jourOY .inti$num.rampe 30 271 30 12 16 0 256
calcul_fft $num 1
update
}

proc close {num} {

destroy .inti$num
}

proc message {text} {

toplevel .msg
wm title .msg "Message"

label .msg.corps -wraplength 4i -justify left -text $text
pack .msg.corps -side top
 
button .msg.button -text "OK" -command {set message_lu 1}
pack .msg.button -side left -expand 1
 
grab .msg
tkwait variable message_lu
grab release .msg
destroy .msg

}

proc saisie_variables {num lscale lradio} {
global parametres

set p [toplevel .param($num)]
wm title $p "Saisie de paramtres"

foreach var $lscale {
	set varname [lindex $var 0]
        set varmin [lindex $var 1]
	set varmax [lindex $var 2]
        if {[llength $var]>3} {
	    set resol [lindex $var 3]
	} else  {
	    set resol 1
	}
	scale $p.sc_$varname -from $varmin -to $varmax\
 	                  -label $varname \
                          -variable parametres($varname) \
	                  -resolution $resol \
                          -orient horizontal
        pack $p.sc_$varname -side top -expand 1
        }
foreach var $lradio {
    set varname [lindex $var 0]
    label $p.lab_$varname -text $varname
    frame $p.fr_$varname
    for {set i 1} {$i < [llength $var]} {incr i} {
	radiobutton $p.but_$varname$i -variable parametres($varname) \
	    -value [expr $i -1] -text [lindex $var $i]
        pack $p.but_$varname$i -in $p.fr_$varname -side left -expand 1
    }
    pack $p.lab_$varname  $p.fr_$varname -side top -expand 1
}
label $p.rampe
button $p.vazy -text "OK" -command {set parametres(fini) glop}
button $p.vazypas -text "Annuler" -command {set parametres(fini) pasglop}
pack $p.vazy $p.vazypas -in $p.rampe -side left -expand 1
pack $p.rampe -side top -expand 1
grab $p
tkwait variable parametres(fini)
grab release $p
destroy $p

}

proc saisie_variable_bis {num lscale} {
global parametres
global image

set p [toplevel .param($num)]
wm geometry $p 200x150+100+500
wm title $p "Saisie de paramtres"
$p configure -background cornflowerblue
foreach var $lscale {
	set varname [lindex $var 0]
    scale $p.sc_$varname -from 0 -to [expr [image width image($num)]/2] \
	    -label $varname \
	    -variable parametres($varname) \
	    -command "dessine_porte $num $varname"\
	    -resolution 1\
	    -orient horizontal
    pack $p.sc_$varname -side top -expand 1
}

label $p.rampe
button $p.vazy -text "OK" -command {set parametres(fini) glop}
button $p.vazypas -text "Annuler" -command {set parametres(fini) pasglop}
pack $p.vazy $p.vazypas -in $p.rampe -side left -expand 1
pack $p.rampe -side top -expand 1
grab $p
tkwait variable parametres(fini)
grab release $p
destroy $p

}

proc dessine_porte {num param rayon} {
global portemax
global portemin
global parametres
global fenetre

set w [image width module($num)]
set h [image height module($num)]
# 4 = epaisseur de bordure
set milieu_x [expr $w/2+4]
set milieu_y [expr $h/2+4]
if {$fenetre==0} {set shape rect} else {set shape oval}
if {$param == "freq_max"} {
    set color red
    catch {.module$num.image delete $portemax(last)}
    set portemax(last) [eval {.module$num.image create $shape} \
			    [expr $milieu_x - $rayon] [expr $milieu_y - $rayon]\
			    [expr $milieu_x + $rayon] [expr $milieu_y + $rayon]\
			    {-tag portemax -outline $color}]
} else {
    set color green
    catch {.module$num.image delete $portemin(last)}
    set portemin(last) [eval {.module$num.image create $shape} \
			    [expr $milieu_x - $rayon] [expr $milieu_y - $rayon]\
			    [expr $milieu_x + $rayon] [expr $milieu_y + $rayon]\
			    {-tag portemin -outline green}]
}
}
 
proc tracerOY {fenetre x0 y0 xfin yfin n min max} {
	$fenetre create line $x0 $y0 $xfin $yfin -arrow last -fill black 
	set valeur $min
	for {set i 0} {$i <= $n} {incr i} {
		set x0n [expr $x0 +(($xfin -$x0)*$i/$n) -4]
		set y0n [expr $y0 +(($yfin -$y0)*$i/$n) -0]
		set xfinn [expr $x0 +(($xfin -$x0)*$i/$n) +4]
		set yfinn [expr $y0 +(($yfin -$y0)*$i/$n) -0]
		$fenetre create line $x0n $y0n $xfinn $yfinn  -fill black
		set xtext [expr $x0n+30]
		set ytext [expr $y0n]
	    $fenetre create text $xtext $ytext -text [format "% 3.2f" $valeur] -tag text_$fenetre
		set valeur [expr $valeur + ($max - $min)/$n]
	}
}


proc mise_a_jourOY {fenetre x0 y0 xfin yfin n min max} {
	$fenetre delete text_$fenetre
	set valeur $min
	for {set i 0} {$i <= $n} {incr i} {
		set x0n [expr $x0 +(($xfin -$x0)*$i/$n) -4]
		set y0n [expr $y0 +(($yfin -$y0)*$i/$n) -0]
		set xtext [expr $x0n+30]
		set ytext [expr $y0n]
	    $fenetre create text $xtext $ytext -text [format "% 3.2f" $valeur] -tag text_$fenetre
		set valeur [expr $valeur + ($max - $min)/$n]
	}
}
