#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tk.h>
#include "photo.hh"
#include "Image.hh"
#include "fft.hh"
#include "test.hh"

/* stockage des infos d'image */

Tk_PhotoImageBlock *blockPtr;

static int TAB[NMAX][NMAX];
static int taille;

struct infoimage{
  Image<int> img;
  Tk_PhotoHandle handle;
  
  COMPLEX** TFourier;

  Image<int> module;
  Tk_PhotoHandle handle_module;
  
  Image<int> phase;
  Tk_PhotoHandle handle_phase;

};

/* Conversion en une image Inti avec allocation eventuelle */
Image<int> tkimage2Inti(Tk_PhotoImageBlock *tkim){
       int i,j;
       int *pixrim;
       unsigned char *pixtk;
       int tw=tkim->width;
       int th=tkim->height;
       Image<int> p(tw,th);

       pixrim=p.PI();
       for (j=0;j<tkim->height;j++) {
          pixtk=tkim->pixelPtr + tkim->pitch*j;
          for (i=0;i<tkim->width;i++) {
              int n = (int)((*(pixtk+tkim->offset[0]) + *(pixtk+tkim->offset[1]) + *(pixtk+tkim->offset[2]))/3);
              *pixrim = n;
              pixtk+=tkim->pixelSize;pixrim++;
          }
       }
       return p;
}

/* conversion en une image tk avec allocation eventuelle */
Tk_PhotoImageBlock *Inti2tkimage(Image<int>& pp,Tk_PhotoImageBlock *tkim) {
       unsigned char *tempotk;
       int *tempoplan;
       int i;
       if (tkim == NULL) {
              tkim = (Tk_PhotoImageBlock *)malloc(sizeof(Tk_PhotoImageBlock));
	      tkim->pixelPtr = NULL;
       }
	   tkim->width=pp.PW();
       tkim->height=pp.PL();
       tkim->pixelSize=3;
       tkim->pitch=tkim->width*tkim->pixelSize;
       tkim->offset[0]=0;
       tkim->offset[1]=1;
       tkim->offset[2]=2;

       if (tkim->pixelPtr == NULL) {
	 tempotk= tkim->pixelPtr=(unsigned char *)malloc(tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       } else {
	 tempotk= tkim->pixelPtr=(unsigned char *)realloc(tkim->pixelPtr,tkim->pixelSize*tkim->width*tkim->height*sizeof(unsigned char));
       }
       tempoplan=pp.PI();
       for (i=0;i<tkim->width*tkim->height;i++) {
	 if (*tempoplan < 256) {
       	*tempotk = *(tempotk+tkim->offset[1]) = *(tempotk+tkim->offset[2]) = (unsigned char)(*tempoplan);
	 } else {
	   int c=(*tempoplan)-500;
	   *(tempotk+tkim->offset[0]) = 255*(c%2); 
	   *(tempotk+tkim->offset[1]) = 255*((c/2)%2);
	   *(tempotk+tkim->offset[2]) = 255*((c/4)%2);}
	tempoplan++;
	tempotk+=tkim->pixelSize;
       }
       return tkim;
}

void freetkim(Tk_PhotoImageBlock *tkim) {
       free(tkim->pixelPtr);
       free(tkim);
}

int Inti_cmd(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage* cdata;
       cdata  = (infoimage*) clientData;
       
       float x,t1,t2;
       int a,b,c,d;
       char *fich;
       int chg_image=0;      
       int chg_fourier=0; 
       int *histo;
       char *extreme_char;
       int L,W;
       int m,i;
	   double min,max;
      
        L = cdata->img.PL();
	W = cdata->img.PW();
	if (strcmp(argv[1],"image_fft") == 0) {
	  extreme_char = (char*)malloc(30*sizeof(char));
	  Image_to_complex(cdata->img,cdata->TFourier); 
	  FFT2D(cdata->TFourier,L,W,1);
	  Calcul_Module(cdata->module,cdata->TFourier,&min,&max);
	  Calcul_phase(cdata->phase,cdata->TFourier);
	  sprintf(extreme_char,"%f",min);
	  Tcl_AppendElement(interp,extreme_char);
	  sprintf(extreme_char,"%f",max);
	  Tcl_AppendElement(interp,extreme_char);
	  chg_fourier = 1;
	  free(extreme_char);
	} else 
	  if (strcmp(argv[1],"fft_image") == 0) {
	    extreme_char = (char*)malloc(30*sizeof(char));
	    FFT2D(cdata->TFourier,L,W,-1);
	    Complex_to_image(cdata->TFourier,cdata->img,&min,&max);
	    sprintf(extreme_char,"%f",min);
	    Tcl_AppendElement(interp,extreme_char);
	    sprintf(extreme_char,"%f",max);
	    Tcl_AppendElement(interp,extreme_char);
	    chg_image = 1;
	    FFT2D(cdata->TFourier,L,W,1);
	    free(extreme_char);
	  } else
	    if (strcmp(argv[1],"CARRE") == 0) {
	      a = atoi(argv[2]);
	      Carre(cdata->img,a);
	      chg_image = 1;
	    } else
	      if (strcmp(argv[1],"CERCLE") == 0) {
		a = atoi(argv[2]);
		Cercle(cdata->img,a);
		chg_image = 1;
	      } else
		if (strcmp(argv[1],"SINUS") == 0) {
		  a = atoi(argv[2]);
		  x = atof(argv[3]);
		  Sinusoide(cdata->img,a,x);
		  chg_image = 1;
		}else
		if (strcmp(argv[1],"CHIRP") == 0) {
		  a = atoi(argv[2]);
		  x = atof(argv[3]);
		  Chirp(cdata->img,a,x);
		  chg_image = 1;
		} else
		  if (strcmp(argv[1],"BANDE") == 0) {
		    a = atoi(argv[2]);
		    x = atof(argv[3]);
		    Bande(cdata->img,a,x);
		    chg_image = 1;
		  } else
		    if (strcmp(argv[1],"haut_bas")==0) {
		      extreme_char = (char*)malloc(30*sizeof(char));
		      a = atoi(argv[2]);b = atoi(argv[3]);c = atoi(argv[4]);
		      Haut_Bas(cdata->TFourier,W,L,a,b,c);
		      Calcul_Module(cdata->module,cdata->TFourier,&min,&max);
		      Calcul_phase(cdata->phase,cdata->TFourier);
		      sprintf(extreme_char,"%f",min);
		      Tcl_AppendElement(interp,extreme_char);
		      sprintf(extreme_char,"%f",max);
		      Tcl_AppendElement(interp,extreme_char);
		      chg_fourier = 1;
		      free(extreme_char);
		    } else
		      if (strcmp(argv[1],"passe_coupe")==0) {
			extreme_char = (char*)malloc(30*sizeof(char));
			a = atoi(argv[2]);b = atoi(argv[3]);
			c = atoi(argv[4]);d = atoi(argv[5]);
			Passe_Coupe(cdata->TFourier,W,L,a,b,c,d);
			Calcul_Module(cdata->module,cdata->TFourier,&min,&max);
			Calcul_phase(cdata->phase,cdata->TFourier);
			sprintf(extreme_char,"%f",min);
			Tcl_AppendElement(interp,extreme_char);
			sprintf(extreme_char,"%f",max);
			Tcl_AppendElement(interp,extreme_char);
			chg_fourier = 1;
			free(extreme_char);
		      } else
			if (strcmp(argv[1],"Ghost")==0) {
			extreme_char = (char*)malloc(30*sizeof(char));
			a = atoi(argv[2]);b = atoi(argv[3]);
			Ghost(cdata->TFourier,W,L,a,b);
			Calcul_Module(cdata->module,cdata->TFourier,&min,&max);
			Calcul_phase(cdata->phase,cdata->TFourier);
			sprintf(extreme_char,"%f",min);
			Tcl_AppendElement(interp,extreme_char);
			sprintf(extreme_char,"%f",max);
			Tcl_AppendElement(interp,extreme_char);
			chg_fourier = 1;
			free(extreme_char);
                      } else
			if (strcmp(argv[1],"THSP")==0) {
			extreme_char = (char*)malloc(30*sizeof(char));
                        x = atof(argv[2]);
                        TH_Spectrum(cdata->TFourier,W,L,x);
			Calcul_Module(cdata->module,cdata->TFourier,&min,&max);
			Calcul_phase(cdata->phase,cdata->TFourier);
			sprintf(extreme_char,"%f",min);
			Tcl_AppendElement(interp,extreme_char);
			sprintf(extreme_char,"%f",max);
			Tcl_AppendElement(interp,extreme_char);
			chg_fourier = 1;
			free(extreme_char);
		      } else
			if (strcmp(argv[1],"NMFSP")==0) {
			extreme_char = (char*)malloc(30*sizeof(char));
                        a = atoi(argv[2]);b = atoi(argv[3]);
			NMS_Spectrum(cdata->TFourier,W,L,a,b);
			Calcul_Module(cdata->module,cdata->TFourier,&min,&max);
			Calcul_phase(cdata->phase,cdata->TFourier);
			sprintf(extreme_char,"%f",min);
			Tcl_AppendElement(interp,extreme_char);
			sprintf(extreme_char,"%f",max);
			Tcl_AppendElement(interp,extreme_char);
			chg_fourier = 1;
			free(extreme_char);
                      }
		      else   
			if (strncmp(argv[1],"save",7) == 0) { fich = argv[2];
			cdata->img.Imagetopgm(fich);chg_image=0;}
	if(chg_image){
	  blockPtr=Inti2tkimage(cdata->img,blockPtr);
	  Tk_PhotoPutBlock(cdata->handle, blockPtr, 0, 0, blockPtr->width, blockPtr->height);
	}
	if(chg_fourier){
	  blockPtr=Inti2tkimage(cdata->module,blockPtr);
	  Tk_PhotoPutBlock(cdata->handle_module, blockPtr, 0, 0, blockPtr->width, blockPtr->height);
	  blockPtr=Inti2tkimage(cdata->phase,blockPtr);
	  Tk_PhotoPutBlock(cdata->handle_phase, blockPtr, 0, 0, blockPtr->width, blockPtr->height);
	}
        return TCL_OK;       
}

int img_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  infoimage *cdata;
  Tk_PhotoImageBlock blockPtr;
  cdata = (infoimage*) clientData;
  char *error_msg;

  if (argc != 4) {
        sprintf(error_msg,"Usage: Imgnew <image> <module> <phase>");
        Tcl_SetResult(interp,error_msg,TCL_VOLATILE);
	return TCL_ERROR;
  }
  
  cdata->handle=Tk_FindPhoto(interp,argv[1]);
  Tk_PhotoGetImage(cdata->handle, &blockPtr);
  cdata->img=tkimage2Inti(&blockPtr);
  int W = (cdata->img).PW();
  int L = (cdata->img).PL();
  
  cdata->TFourier = (COMPLEX **)calloc(W,sizeof(COMPLEX*));
  for (int i=0;i<W;i++)
 	cdata->TFourier[i] = (COMPLEX *)calloc(L,sizeof(COMPLEX));

  cdata->handle_module=Tk_FindPhoto(interp,argv[2]);
  Tk_PhotoGetImage(cdata->handle_module, &blockPtr);
  cdata->module=tkimage2Inti(&blockPtr);

  cdata->handle_phase=Tk_FindPhoto(interp,argv[3]);
  Tk_PhotoGetImage(cdata->handle_phase, &blockPtr);
  cdata->phase=tkimage2Inti(&blockPtr);


 return TCL_OK;
}
/* creation d'une image de type Inti */
/* Intinew <nomimage> <nomcommanderet> */

void init_retcc() {
blockPtr = NULL;
}

int Inti_new(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
       infoimage *cdata;
       char *error_msg;

	if (argc != 2) {
             sprintf(error_msg,"Usage: Intinew <nomcommande>");
             Tcl_SetResult(interp,error_msg,TCL_VOLATILE);
             return TCL_ERROR;
	}
        
 cdata = new infoimage;
         Tcl_CreateCommand(interp, "Imgnew", img_new, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
         Tcl_CreateCommand(interp, argv[1], Inti_cmd, (ClientData)cdata,(Tcl_CmdDeleteProc *)NULL);
         return TCL_OK;
}


