#include "Image.hh"
#include "test.hh"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

void Efface(Image<int>& p)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
 
  for (j=0;j<L;j++)
    for (i=0;i<W;i++) {
       PIX[index++]=0;
	}
}

void Carre(Image<int>& p,int rayon)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
 
  for (j=0;j<L;j++)
    for (i=0;i<W;i++) {
	  if ((abs((W/2)-i) < rayon)&&(abs((L/2)-j) < rayon))
		PIX[index]=255; else PIX[index]=0;
	  index++;
	}
}



void Cercle(Image<int>& p,int rayon)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
 
  for (j=0;j<L;j++)
    for (i=0;i<W;i++) {
	   if ((((W/2)-i)*((W/2)-i))+(((L/2)-j)*((L/2)-j)) < rayon*rayon)
		 PIX[index]=255; else PIX[index]=0;
	  index++;
	}
}


void Sinusoide(Image<int>& p,int freq,float angle)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
  double PI=3.14159265358979323846;
  double theta;
  double decal; 
  
 if (angle > 45) {
   theta = ((90-angle)*PI)/180;
   decal = tan(theta);
   for (j=0;j<L;j++)
	 for (i=0;i<W;i++) 
	   PIX[index++] = (int)(round(((sin((freq*2*PI*(i+(j*decal)))/double(W)) + 1)*255)/2));
 } else {
   theta = (angle*PI)/180;
   decal = tan(theta);
   for (i=0;i<W;i++) 
	 for (j=L-1;j>=0;j--) 
	   PIX[j*W+i] = (int)(round(((sin((freq*2*PI*(j+(i*decal)))/double(L)) + 1)*255)/2));
 }
   
}

void Bande(Image<int>& p,int frequence,float angle)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
  double PI=3.14159265358979323846;
  double theta;
  double decal; 
  int newx,newy;
  
  int longueur = W/frequence;

 if (angle > 45) {
   theta = ((90-angle)*PI)/180;
   decal = tan(theta);
   for (j=0;j<L;j++)
	 for (i=0;i<W;i++) { 
	   newx = (int)(round(i+j*decal));
	   if ((newx/longueur)%2 == 0) PIX[index]=0; else PIX[index]=255;
	   index++;
	 }
 } else {
   theta = (angle*PI)/180;
   decal = tan(theta);
   for (i=0;i<W;i++) 
	 for (j=L-1;j>=0;j--) {
	   newy = (int)(round(j+i*decal));
	   if ((newy/longueur)%2 == 0) PIX[j*W+i]=0; else PIX[j*W+i]=255;
	 }
 }
   
}

void Chirp(Image<int>& p,int freqmax,float angle)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
  double PI=3.14159265358979323846;
  double theta;
  double decal; 
  double freq;

  double normal;
 if (angle > 45) {
   theta = ((90-angle)*PI)/180;
   decal = tan(theta);
   normal = double(W)+(double(L)*decal);
   for (j=0;j<L;j++)
     for (i=0;i<W;i++) {
       freq = ((i+(j*decal))*freqmax)/normal;
	   PIX[index++] = (int)(round(((sin((freq*2*PI*(i+(j*decal)))/double(W)) + 1)*255)/2));
     }
 } else {
   theta = (angle*PI)/180;
   decal = tan(theta);
   normal = double(L)+(double(W)*decal);
   for (i=0;i<W;i++)
     for (j=L-1;j>=0;j--) {
       freq = ((j+(i*decal))*freqmax)/normal;
       PIX[j*W+i] = (int)(round(((sin((freq*2*PI*(j+(i*decal)))/double(L)) + 1)*255)/2));  
     }
 }
   
}

void Chirp_old(Image<int>& p,int freqmax,float angle)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
  double PI=3.14159265358979323846;
  double theta;
  double decal; 
  double freq;
  double normal;

   theta = (angle*PI)/180;
   normal = W*sin(theta)+L*cos(theta);
   for (i=0;i<W;i++)
     for (j=L-1;j>=0;j--) {
       freq = (i*sin(theta)+j*cos(theta)*freqmax)/normal;
       PIX[j*W+i] = (int)(round(((sin((freq*freq*2*PI)/double(L)) + 1)*255)/2));
     }
   
}


void Chirp2d(Image<int>& p,int freqmax,float angle)

{
  int index=0;
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();
  int i,j ; 
  double PI=3.14159265358979323846;
  double theta;
  double decal; 
  double freq;

  double normal;
 if (angle > 45) {
   theta = ((90-angle)*PI)/180;
   decal = tan(theta);
   normal = double(W)*double(L);
   for (j=0;j<L;j++)
     for (i=0;i<W;i++) {
	   freq = (i*j*freqmax)/normal;
	   PIX[index++] = (int)(round((sin(2*freq) + 1)*255)/2);
     }
 } else {
   theta = (angle*PI)/180;
   decal = tan(theta);
   normal = double(L)*double(W);
   for (i=0;i<W;i++)
     for (j=L-1;j>=0;j--) {
       freq = (j*i*freqmax)/normal;
	   PIX[j*W+i] = (int)(round((sin(2*freq) + 1)*255)/2);
     }
 }
   
}
